
package de.ivu.elect.presentation.wahlrechtspruefung.menu;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahlrechtspruefung.boundary.WahlrechtspruefungEdit;
import de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus;
import de.ivu.elect.business.wahlrechtspruefung.entity.Wahlrechtspruefung;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.wahlrechtspruefung.WahlrechtspruefungSearchView;

public class WahlrechtspruefungAlleAufErfuelltSetzenMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlrechtspruefungEdit wahlrechtspruefungEdit;

  @Inject
  @View
  private transient WahlrechtspruefungSearchView wahlrechtspruefungSearchView;

  public WahlrechtspruefungAlleAufErfuelltSetzenMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return FacesContextUtil.isDevelopmentStage();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY; // nur im "Developer-Modus" aktiv
  }

  @Override
  public boolean isDisabledInternal() {
    return false;
  }

  @Override
  public String getTargetViewId() {
    return null;
  }

  @Override
  public String doAction() {
    for (Wahlrechtspruefung wahlrechtspruefung : wahlrechtspruefungSearchView.getSearchResult()) {
      wahlrechtspruefungEdit.setzeWahlrechtspruefungStatus(wahlrechtspruefung, WahlrechtspruefStatus.ERFUELLT);
    }

    wahlrechtspruefungSearchView.resetSearchResult();

    return WahlrechtspruefungSearchView.VIEW_ID;
  }

  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), "Alle auf erfüllt setzen (NUR ZUR ENTWICKLUNG)");
  }

  @Override
  public String getLabelKey() {
    return Messages.LOCALIZED_MESSAGE_ONLY_MSG_KEY;
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return Collections.singletonList("");
  }
}
